org.apache.tinkerpop.gremlin.process.traversal.strategy.optimization

## Class IncidentToAdjacentStrategy

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.strategy.AbstractTraversalStrategy<TraversalStrategy.OptimizationStrategy>
  - - org.apache.tinkerpop.gremlin.process.traversal.strategy.optimization.IncidentToAdjacentStrategy

- All Implemented Interfaces:
    Serializable, Comparable<Class<? extends TraversalStrategy>>, TraversalStrategy<TraversalStrategy.OptimizationStrategy>, TraversalStrategy.OptimizationStrategy

      public final class IncidentToAdjacentStrategy
      extends AbstractTraversalStrategy<TraversalStrategy.OptimizationStrategy>
      implements TraversalStrategy.OptimizationStrategy

  This strategy looks for `.outE().inV()`, `.inE().outV()` and `.bothE().otherV()` and replaces these step sequences with `.out()`, `.in()` or `.both()` respectively. The strategy won't modify the traversal if:

  - the edge step is labeled
  - the traversal contains a `path` step
  - the traversal contains a lambda step

  By re-writing the traversal in this fashion, the traversal eliminates unnecessary steps and becomes more normalized.
  Author:
    Daniel Kuppitz (http://gremlin.guru)
  See Also:
    Serialized Form
  Example:

         __.outE().inV()         // is replaced by __.out()
         __.inE().outV()         // is replaced by __.in()
         __.bothE().otherV()     // is replaced by __.both()
         __.bothE().bothV()      // will not be modified
         __.outE().inV().path()  // will not be modified
         __.outE().inV().tree()  // will not be modified

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.TraversalStrategy

      `TraversalStrategy.DecorationStrategy, TraversalStrategy.FinalizationStrategy, TraversalStrategy.OptimizationStrategy, TraversalStrategy.ProviderOptimizationStrategy, TraversalStrategy.VerificationStrategy`

  - ### Field Summary

    - ### Fields inherited from interface org.apache.tinkerpop.gremlin.process.traversal.TraversalStrategy

      `STRATEGY`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `apply(Traversal.Admin<?,?> traversal)`
    `Set<Class<? extends TraversalStrategy.OptimizationStrategy>>` | `applyPost()` The set of strategies that must be executed after this strategy is executed.
    `Set<Class<? extends TraversalStrategy.OptimizationStrategy>>` | `applyPrior()` The set of strategies that must be executed before this strategy is executed.
    `static IncidentToAdjacentStrategy` | `instance()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.strategy.AbstractTraversalStrategy

      `equals, hashCode, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.TraversalStrategy.OptimizationStrategy

      `compareTo, getTraversalCategory`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.TraversalStrategy

      `getConfiguration`

- - ### Method Detail

    - #### instance

          public static IncidentToAdjacentStrategy instance()

    - #### apply

          public void apply(Traversal.Admin<?,?> traversal)

      Specified by:
        `apply` in interface `TraversalStrategy<TraversalStrategy.OptimizationStrategy>`

    - #### applyPrior

          public Set<Class<? extends TraversalStrategy.OptimizationStrategy>> applyPrior()

      Description copied from interface: `TraversalStrategy`
      The set of strategies that must be executed before this strategy is executed. If there are no ordering requirements, the default implementation returns an empty set.
      Specified by:
        `applyPrior` in interface `TraversalStrategy<TraversalStrategy.OptimizationStrategy>`
      Returns:
        the set of strategies that must be executed prior to this one.

    - #### applyPost

          public Set<Class<? extends TraversalStrategy.OptimizationStrategy>> applyPost()

      Description copied from interface: `TraversalStrategy`
      The set of strategies that must be executed after this strategy is executed. If there are no ordering requirements, the default implementation returns an empty set.
      Specified by:
        `applyPost` in interface `TraversalStrategy<TraversalStrategy.OptimizationStrategy>`
      Returns:
        the set of strategies that must be executed post this one

Copyright © 2013–2021 Apache Software Foundation. All rights reserved.